package abchr;

import abchr.audio.Sample;

import java.util.List;
import java.util.ArrayList;

public class ABXTestImpl implements ABXTest {
	private final List<ABXTrial> trials=new ArrayList<ABXTrial>();
	private final Sample aSample;
	private final Sample bSample;
	private int correct=0;

	public ABXTestImpl(Sample aSample,Sample bSample) {
		this.aSample=aSample;
		this.bSample=bSample;
	}

	public Sample getASample(){return aSample;}
	public Sample getBSample(){return bSample;}

	public void addTrial(ABXTrial trial){trials.add(trial);if(trial.getCorrect()){correct++;}}
	public ABXTrial getTrial(int index){return trials.get(index);}

	public int getNumTrials(){return trials.size();}
	public int getCorrect(){return correct;}

	public boolean getResult(int index){return getTrial(index).getCorrect();}

	public float pVal(){return pVal(getNumTrials(),getCorrect());}

	public static float pVal(int n,int correct) {
		double result=0;
		double binom;
		int twos;
		for(int k=correct;k<=n;k++) {
			twos=n;
			binom=1;
			for(int j=0;j<k;j++) {
				binom*=(n-j)/(double)(k-j);
				while(binom>2 && twos>0){binom/=2;--twos;}
			}
			for(int j=0;j<twos;j++){binom/=2;}
			result+=binom;
		}
		return (float)result;
	}
}
