package abchr;

import java.io.IOException;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class AbstractAttributable implements Attributable, Serializable {
	private Map attributeMap=new HashMap(8,0.75f);
	//private CrappyMap crappyMap=new CrappyMap(4);
	//private boolean useCrappyMap=true;

	public void setAttribute(Object key,Object value) {
		attributeMap.put(key,value);
	}

	public Object getAttribute(Object key) {
		return attributeMap.get(key);
	}

	public boolean hasAttribute(Object key) {
		return attributeMap.containsKey(key);
	}

	public Iterator<Map.Entry> iterator() {
		return attributeMap.entrySet().iterator();
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		out.writeInt(attributeMap.size());
		Map.Entry entry;
		for(Iterator it=attributeMap.entrySet().iterator();it.hasNext();) {
			entry=(Map.Entry)it.next();
			out.writeObject(entry.getKey());
			out.writeObject(entry.getValue());
		}
	}

	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		int size=in.readInt();
		attributeMap=new HashMap(size*2,0.75f);
		for(int i=0;i<size;i++) {
			attributeMap.put(in.readObject(),in.readObject());
		}
	}
}
