package abchr;

import org.jdom.Element;

import java.io.IOException;

public class ComparisonModule implements ProjectModule {
	private SampleConfigModule sampleConfig;

	private ComparisonGroup[] groups;

	public ComparisonModule(RawTestConfig rawConfig,SampleConfigModule sampleConfig) {
		this.sampleConfig=sampleConfig;
		groups=new ComparisonGroup[sampleConfig.getSampleCount()];
		for(int i=0;i<sampleConfig.getSampleCount();i++) {
			groups[i]=new ComparisonGroup(sampleConfig.getOriginalSample(),sampleConfig.getSample(i),true);
		}
	}

	public int getGroupCount(){return groups.length;}
	public ComparisonGroup getGroup(int index){return groups[index];}

	public Element toResultsXML() {
		Element root=new Element("ABCHR");
		Element e;
		for(int i=0,n=groups.length;i<n;i++) {
			e=new Element("Comparison");
			e.addContent(new Element("SampleID").setText(Integer.toString(i)));
			e.addContent(new Element("RefIndex").setText(Integer.toString(groups[i].getOriginalIndex())));
			e.addContent(new Element("RankedIndex").setText(Integer.toString(groups[i].getRatedBadIndex())));
			if(groups[i].getRatedBadIndex()!=-1) {
				e.addContent(new Element("Rating").setText(Double.toString(groups[i].getRating(groups[i].getRatedBadIndex()).getValue()/10.0d)));
				e.addContent(new Element("Comment").setText(groups[i].getComment(groups[i].getRatedBadIndex())));
			}
			root.addContent(e);
		}
		return root;
	}

	public static ProjectModule createInstance(RawTestConfig rawConfig,SampleConfigModule sampleConfig) {
		return new ComparisonModule(rawConfig,sampleConfig);
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		//System.out.println("Writing ComparisonModule");
		out.defaultWriteObject();
		//System.out.println("Done writing ComparisonModule");
	}
}