package abchr;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class ConfigIOManager {
	private static final ConfigIOManager INSTANCE=new ConfigIOManager();

	public static ConfigIOManager getInstance(){return INSTANCE;}

	private List modules=new ArrayList(3);

	private ConfigIOManager() {
		BufferedReader reader=null;
		try {
			reader=new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream("configio.cfg")));
			String line;
			String[] items;
			while((line=reader.readLine())!=null) {
				items=line.split(",");
				try {
					modules.add(new ConfigIOModule(((Class<ConfigIO>)Class.forName(items[0])).newInstance(),items[2],items[1],items.length>3));
				} catch(InstantiationException e) {
					System.out.println("ConfigIO module "+items[0]+" could not be initialized");
				} catch(IllegalAccessException e) {
					System.out.println("ConfigIO module "+items[0]+" could not be initialized");
				} catch(ClassNotFoundException e) {
					System.out.println("ConfigIO module "+items[0]+" could not be initialized");
				}
			}
		} catch(FileNotFoundException e) {
			throw new RuntimeException("configio.cfg could not be found");
		} catch(IOException e) {
			throw new RuntimeException("configio.cfg could not be read");
		}
		/*modules.add(new ConfigIOModule(new IniConfigIO(),"txt","Config Files",true));
		modules.add(new ConfigIOModule(new ScrambledConfigIO(),"ecf","Encrypting Config Files",false));
		modules.add(new ConfigIOModule(new XMLConfigIO(),"xml","XML Config Files",true));*/
	}

	public ConfigIOModule[] getModules() {
		return (ConfigIOModule[])modules.toArray(new ConfigIOModule[0]);
	}
}
