package abchr;

import java.util.Iterator;
import java.util.Map;
import java.util.NoSuchElementException;

public class CrappyMap {
	private static class Entry implements Map.Entry {
		private Object key,value;

		public Entry(Object key,Object value) {
			this.key=key;
			this.value=value;
		}

		public Object getKey(){return key;}
		public Object getValue(){return value;}

		public boolean equals(Object o) {
			if(o==null || !(o instanceof Entry)){return false;}
			Entry obj=(Entry)o;
			return obj.key.equals(key) && obj.value.equals(value);
		}

		public int hashCode() {
			return 29*key.hashCode()+value.hashCode();
		}

		public Object setValue(Object value) {
			throw new UnsupportedOperationException();
		}
	}

	private class CrappyMapIterator implements Iterator {
		private int nextIndex;

		public boolean hasNext() {
			return nextIndex!=-1;
		}

		public Object next() {
			if(nextIndex==-1){throw new NoSuchElementException();}
			Entry result=new Entry(keyArray[nextIndex],valueArray[nextIndex]);
			int oldNextIndex=nextIndex;
			for(int i=nextIndex+1;i<keyArray.length;i++) {
				if(keyArray[i]!=null){nextIndex=i;break;}
			}
			if(nextIndex==oldNextIndex){nextIndex=-1;}
			return result;
		}

		public void remove() {

		}

		public CrappyMapIterator() {
			nextIndex=-1;
			for(int i=0;i<keyArray.length;i++) {
				if(keyArray[i]!=null){nextIndex=i;break;}
			}
		}
	}

	public Object[] keyArray;
	public Object[] valueArray;

	public Object get(Object key) {
		for(int i=0;i<keyArray.length;i++) {
			if(keyArray[i]==null){continue;}
			if(key.equals(keyArray[i])){return valueArray[i];}
		}
		return null;
	}

	public void put(Object key,Object value) {
		if(contains(key)){return;}
		for(int i=0;i<keyArray.length;i++) {
			if(keyArray[i]==null) {
				keyArray[i]=key;
				valueArray[i]=value;
			}
		}
	}

	public boolean contains(Object key) {
		for(int i=0;i<keyArray.length;i++) {
			if(keyArray[i]==null){continue;}
			if(key.equals(keyArray[i])){return true;}
		}
		return false;
	}

	public boolean isFull() {
		for(int i=0;i<keyArray.length;i++) {
			if(keyArray[i]==null){return false;}
		}
		return true;
	}

	public Iterator getEntryIterator() {
		return new CrappyMapIterator();
	}

	public Object[] getKeyArray(){return keyArray;}
	public Object[] getValueArray(){return valueArray;}

	public CrappyMap(int capacity) {
		keyArray=new Object[capacity];
		valueArray=new Object[capacity];
	}
}
