package abchr;

import org.jdom.Element;
import abchr.audio.Sample;
import abchr.audio.FileSample;

import java.io.IOException;

public class HashCheckModule extends AbstractProjectModule {
	private SampleConfigModule sampleConfig;

	public HashCheckModule(SampleConfigModule sampleConfig) {
		this.sampleConfig=sampleConfig;
	}

	public String hashCheck(Sample s) {
		if(!(s instanceof FileSample)) {
			return "Not checked";
		} else if(!SampleHash.hashPresent(s)) {
			return "No hash present";
		} else {
			try {
				return ((FileSample)s).checkHash()?"Match":"Mismatch";
			} catch(IOException e1) {
				return "Not checked";
			}
		}
	}

	private Element makeHashElement(Sample s) {
		Element h=new Element("HashMatch");
		h.setText(hashCheck(s));
		return h;
	}

	public Element toResultsXML() {
		Element root=new Element("Hashes");
		Element e=new Element("Sample");
		e.addContent(new Element("ID").setText("-1"));
		e.addContent(makeHashElement(sampleConfig.getOriginalSample()));
		root.addContent(e);
		for(int i=0,n=sampleConfig.getSampleCount();i<n;i++) {
			e=new Element("Sample");
			e.addContent(new Element("ID").setText(Integer.toString(i)));
			e.addContent(makeHashElement(sampleConfig.getSample(i)));
			root.addContent(e);
		}
		return root;
	}

	public static ProjectModule createInstance(SampleConfigModule sampleConfig) {
		return new HashCheckModule(sampleConfig);
	}
}