package abchr;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

public class IniStringMap {
	private final Map map=new HashMap();

	public IniStringMap(InputStream stream) throws IOException,ParseException {
		BufferedReader br=new BufferedReader(new InputStreamReader(stream));
		StringBuffer buffer=new StringBuffer();
		String line=br.readLine();
		while(line!=null) {
			buffer.append(line+'\n');
			line=br.readLine();
		}
		br.close();
		String text=buffer.toString();
		String[] lines=text.split("\n");
		int n=lines.length;
		int empty=0;
		for(int i=0;i<n;i++){lines[i]=lines[i].trim();if(lines[i].equals("") || lines[i].startsWith("//")){empty++;}}
		String[][] split=new String[n-empty][];
		int j=0;
		for(int i=0;i<n;i++) {
			if(lines[i].equals("") || lines[i].startsWith("//")){continue;}
			split[j]=lines[i].split("=",2);
			if(split[j].length!=2){throw new ParseException("Could not parse line "+(i+1)+": "+lines[i]);}
			map.put(split[j][0].trim(),split[j][1].trim());
			j++;
		}
	}

	public String get(String key){return (String)map.get(key);}
	public boolean contains(String key){return map.containsKey(key);}
}