package abchr;

import abchr.audio.Sample;

import java.util.ArrayList;
import java.util.List;

public class ListenableABXTest implements ABXTest {
	protected final ABXTest base;
	private transient final List listeners=new ArrayList(2);

	public ListenableABXTest(ABXTest base){this.base=base;}

	public void addListener(ABXListener listener){if(!listeners.contains(listener))listeners.add(listener);}
	public void removeListener(ABXListener listener){listeners.remove(listener);}

	protected void notifyListeners() {
		for(int i=0,n=listeners.size();i<n;i++) {
			((ABXListener)listeners.get(i)).changed(base);
		}
	}

	public Sample getASample(){return base.getASample();}
	public Sample getBSample(){return base.getBSample();}
	public int getNumTrials(){return base.getNumTrials();}
	public int getCorrect(){return base.getCorrect();}
	public boolean getResult(int index){return base.getResult(index);}
	public float pVal(){return base.pVal();}
	public void addTrial(ABXTrial trial) {
		base.addTrial(trial);
		notifyListeners();
	}
	public ABXTrial getTrial(int index){return base.getTrial(index);}
}