package abchr;

import java.util.List;
import java.util.ArrayList;

public class ResultIOManager {
	private static final ResultIOManager INSTANCE=new ResultIOManager();

	public static ResultIOManager getInstance(){return INSTANCE;}

	private List modules=new ArrayList(3);

	private ResultIOManager() {
		modules.add(new ResultIOModule(new TxtResultIO(),"txt","Text Result Files",true));
		modules.add(new ResultIOModule(new ScrambledResultIO(),"erf","Encrypted Result Files",false));
		modules.add(new ResultIOModule(new XMLResultIO(),"arf","ABC/HR XML Result Files",true));
	}

	public ResultIOModule[] getModules() {
		return (ResultIOModule[])modules.toArray(new ResultIOModule[0]);
	}
}
