package abchr;

import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.UnsupportedAudioFileException;
import java.io.File;
import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class SampleHash {
	private static Integer key=new Integer(830256111);

	public static byte[] getHash(Attributable attributable) {
		byte[] hash=(byte[])attributable.getAttribute(key);
		return hash;
	}

	public static void setHash(Attributable attributable,byte[] hash) {
		attributable.setAttribute(key,hash);
	}

	public static boolean hashPresent(Attributable attributable) {
		return attributable.hasAttribute(key);
	}

	public static byte[] computeHash(File sample,String algorithm) throws IOException,NoSuchAlgorithmException {
		AudioInputStream stream;
		try {
			stream=AudioSystem.getAudioInputStream(sample);
		} catch(UnsupportedAudioFileException e) {
			throw new IOException();
		}
		MessageDigest md;
		md=MessageDigest.getInstance(algorithm);
		byte[] buffer=new byte[10240];
		int read;
		while((read=stream.read(buffer))!=-1) {
			md.update(buffer,0,read);
		}
		return md.digest();
	}
}
