package abchr;

import org.jdom.Document;
import org.jdom.Element;

import java.io.IOException;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

public class TestProject implements Serializable {
	static final long serialVersionUID = -7672373933167496259L;

	private List testModules=new ArrayList();

	public void addModule(ProjectModule module){testModules.add(module);}
	public List getModules(){return Collections.unmodifiableList(testModules);}

	public Document getResults() {
		ProjectModule module;
		Element root=new Element("Results");
		root.addContent(new Element("Version").setText(System.getProperty("abchr-java-versionstring")));
		Element os=new Element("OS");
		os.addContent(new Element("Architecture").setText(System.getProperty("os.arch")));
		os.addContent(new Element("Name").setText(System.getProperty("os.name")));
		os.addContent(new Element("Version").setText(System.getProperty("os.version")));
		root.addContent(os);
		root.addContent(new Element("Date").setText(new SimpleDateFormat("dd MMMM yyyy").format(new Date())));

		for(int i=0;i<testModules.size();i++) {
			module=(ProjectModule)testModules.get(i);
			Element e=module.toResultsXML();
			if(e!=null){root.addContent(e);}
		}
		return new Document(root);
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		//System.out.println("Writing TestProject");
		out.writeObject(testModules);
	}

	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		testModules=(List)in.readObject();
	}
}