package abchr;

import org.jdom.Element;

import java.io.IOException;
import java.util.prefs.Preferences;
import java.util.prefs.BackingStoreException;

public class TesterNameModule implements ProjectModule {
	private String testerName="";

	public TesterNameModule(String tester) {
		this.testerName=tester;
	}

	public String getTesterName(){return testerName;}
	public void setTesterName(String testerName){this.testerName=testerName;}

	public Element toResultsXML() {
		updateInitValue();
		return new Element("TesterName").setText(testerName);
	}

	private void updateInitValue() {
		Preferences prefs=Preferences.userRoot().node("/abchr");
		if(!testerName.equals("")) {
			prefs.put("testername",testerName);
			try {
				prefs.flush();
			} catch(BackingStoreException e){}
		}
	}

	public static ProjectModule createInstance() {
		Preferences prefs=Preferences.userRoot().node("/abchr");
		String tester=prefs.get("testername","");
		return new TesterNameModule(tester);
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		//System.out.println("Writing TesterNameModule");
		out.defaultWriteObject();
		//System.out.println("Done writing TesterNameModule");
	}
}
