package abchr;

import javax.swing.*;
import java.io.IOException;

public class TimeLineModule extends AbstractProjectModule {
	private TestConfig config;
	private transient BoundedRangeModel rangeModel;

	public TimeLineModule(TestConfig config) {
		this.config=config;
		init();
	}

	public BoundedRangeModel getRangeModel(){return rangeModel;}

	private void init() {
		int length=(int)(config.getOriginalSample().getLength()*1000);
		for(int i=0,n=config.getSampleCount();i<n;i++) {
			length=Math.min(length,(int)(config.getSample(i).getLength()*1000));
		}
		rangeModel=new DefaultBoundedRangeModel(0,length,0,length);
	}

	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		init();
	}

	public static ProjectModule createInstance(TestConfig config) {
		return new TimeLineModule(config);
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		//System.out.println("Writing TimeLineModule");
		out.defaultWriteObject();
		//System.out.println("Done writing TimeLineModule");
	}

}
