package abchr;

import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class XMLConfigIO implements ConfigIO {
	static final String JAXP_SCHEMA_LANGUAGE="http://java.sun.com/xml/jaxp/properties/schemaLanguage";
	static final String W3C_XML_SCHEMA="http://www.w3.org/2001/XMLSchema";
	static final String JAXP_SCHEMA_SOURCE="http://java.sun.com/xml/jaxp/properties/schemaSource";

	public Document readConfig(InputStream in) throws IOException {
		SAXBuilder builder=new SAXBuilder(false);
		Document document=null;
		try {
			document=builder.build(in);
		} catch(JDOMException e) {
			throw new IOException("XML file could not be parsed.");
		}
		return document;
	}

	public void writeConfig(OutputStream out,Document doc) throws IOException {
		org.jdom.output.XMLOutputter outputter=new org.jdom.output.XMLOutputter(org.jdom.output.Format.getPrettyFormat());
		outputter.output(doc,out);
	}
}