package abchr;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

import java.io.File;

public class XMLUtils {
	public static Element createTextElement(Document doc,String tagName,String text) {
		Element e=doc.createElement(tagName);
		e.appendChild(doc.createTextNode(text));
		return e;
	}

	public static org.jdom.Element createJDomTextElement(String tagName,String text) {
		return new org.jdom.Element(tagName).setText(text);
	}

	public static String unpackTextNode(Node node) {
		if(node.getFirstChild()==null){return "";}
		return ((Text)node.getFirstChild()).getNodeValue();
	}

	public static String unpackPathNode(Node node) {
		String path=unpackTextNode(node);
		path.replace('\\',File.separatorChar);
		path.replace('/',File.separatorChar);
		return path;
	}

	public static Element getChildElement(Element e,String tag) {
		return (Element)e.getElementsByTagName(tag).item(0);
	}
}
