package abchr.audio;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import java.util.Map;
import java.util.Iterator;

abstract class SampleDelegator implements Sample {
	private transient Sample baseSample=null;

	protected SampleDelegator(Sample baseSample){this.baseSample=baseSample;}
	protected SampleDelegator(){}

	protected void setBaseSample(Sample baseSample){this.baseSample=baseSample;}

	public Object getAttribute(Object key){return baseSample.getAttribute(key);}
	public AudioFormat getFormat(){return baseSample.getFormat();}
	public float getLength(){return baseSample.getLength();}
	public void setLength(float length){baseSample.setLength(length);}
	public AudioInputStream getStream(){return baseSample.getStream();}
	public boolean hasAttribute(Object key){return baseSample.hasAttribute(key);}
	public void setAttribute(Object key,Object value){baseSample.setAttribute(key,value);}
	public Iterator<Map.Entry> iterator(){return baseSample.iterator();}
}