package abchr.gui;

import abchr.Attributable;
import abchr.audio.SampleGain;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;

class GainSpinner implements AttributableView,ChangeListener {
	private JSpinner spinner=new JSpinner(new SpinnerNumberModel(new Float(0.0),null,null,new Float(0.01)));
	private Attributable model;

	public JComponent getComponent(){return spinner;}
	public String getName(){return "Gain";}

	public void setModel(Attributable model) {
		this.model=model;
		spinner.setValue(model==null?new Float(0.0):SampleGain.getGainObj(model));
	}

	public GainSpinner(Attributable model) {
		spinner.setPreferredSize(new Dimension(70,spinner.getPreferredSize().height));
		spinner.addChangeListener(this);
		setModel(model);
	}

	public GainSpinner(){this(null);}

	public void stateChanged(ChangeEvent e) {
		if(model==null){return;}
		SampleGain.setGain(model,(Float)spinner.getValue());
	}
}
