package abchr.gui;

import javax.swing.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.prefs.Preferences;

public class Main {
	public static JFrame frame;

	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(new com.jgoodies.looks.plastic.PlasticLookAndFeel());
		} catch(Exception e){}
		Preferences prefs=Preferences.userRoot().node("/abchr");
		File dir=new File(prefs.get("userdir",System.getProperty("user.dir")));
		if(dir.exists() && dir.isDirectory()) {
			System.setProperty("abchr.dir",dir.getAbsolutePath());
		}
		System.setProperty("abchr-java-versionstring-long","ABC/Hidden Reference for Java\nVersion 0.5b, 30 August 2005\n\n");
		System.setProperty("abchr-java-versionstring","ABC/HR for Java, Version 0.5b");
		frame=new ProjectFrame();
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				cleanUp();
				System.exit(0);
			}
		});
	}

	private static void cleanUp() {
		Preferences prefs=Preferences.userRoot().node("/abchr");
		String dirStr=System.getProperty("abchr.dir");
		File dir=new File(dirStr!=null?dirStr:System.getProperty("user.dir"));
		prefs.put("userdir",dir==null?System.getProperty("user.dir"):dir.getAbsolutePath());
		File tempdir=new File("."+File.separatorChar+"abchrtemp");
		if(!tempdir.exists()){return;}
		File[] tempFiles=tempdir.listFiles();
		for(int i=0;i<tempFiles.length;i++) {
			if(tempFiles[i].getName().startsWith("tmp")) {
				tempFiles[i].delete();
			}
		}
	}
}