package abchr.gui;

import abchr.Attributable;
import abchr.audio.SampleOffset;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;

class OffsetSpinner implements AttributableView,ChangeListener {
	private JSpinner spinner=new JSpinner(new SpinnerNumberModel(new Integer(0),new Integer(0),null,new Integer(1)));
	private Attributable model;

	public JComponent getComponent(){return spinner;}
	public String getName(){return "Offset";}

	public void setModel(Attributable model) {
		this.model=model;
		spinner.setValue(model==null?new Integer(0):SampleOffset.getOffsetObj(model));
	}

	public OffsetSpinner(Attributable model) {
		spinner.setPreferredSize(new Dimension(50,spinner.getPreferredSize().height));
		spinner.addChangeListener(this);
		setModel(model);
	}

	public OffsetSpinner(){this(null);}

	public void stateChanged(ChangeEvent e) {
		if(model==null){return;}
		SampleOffset.setOffset(model,(Integer)spinner.getValue());
	}
}
