package abchr.gui;

import abchr.ParseException;
import abchr.ProjectLoader;
import jlfgr.GraphicsRepository;
import org.jdom.Document;

import javax.swing.*;
import java.awt.event.ActionEvent;

class SetupTestAction extends AbstractAction {
	private ProjectFrame frame;
	private TestSetupDialog dialog=null;

	public SetupTestAction(ProjectFrame frame) {
		super("New ABC/HR Test...",GraphicsRepository.getToolbarIcon("general/New16.gif"));
		this.putValue(Action.SHORT_DESCRIPTION,"Set up a new ABC/HR test");
		this.frame=frame;
	}

	public void actionPerformed(ActionEvent e) {
		lazyInit();
		Document document=dialog.showDialog();
		if(document!=null) {
			try {
				if(!frame.closeProject()){return;}
				frame.load(ProjectLoader.load(document));
			} catch(ParseException e1) {
				JOptionPane.showMessageDialog(frame,"Configuration could not be loaded.\n"+e1.getMessage(),"Error",JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	private void lazyInit() {
		if(dialog==null){dialog=new TestSetupDialog(frame);}
	}
}