package abchr.gui.modulecontrols;

import abchr.ComparisonModule;
import abchr.ProjectModule;
import abchr.gui.ControlPosition;

import javax.swing.*;
import java.awt.*;

public class ComparisonPanelFactory implements ModuleControlFactory {
	private static class ScrollPane extends JScrollPane implements ModuleControl {
		private ComparisonPanel panel;

		public ScrollPane(ComparisonPanel panel) {
			super(panel,JScrollPane.VERTICAL_SCROLLBAR_NEVER,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			this.panel=panel;
		}
		
		public void setModule(ProjectModule module) {
			panel.setModule(module);
			this.setPreferredSize(new Dimension(panel.getWidth(),panel.getPreferredSize().height+(panel.getPreferredSize().getWidth()>this.getWidth()?20:5)));
		}
	}

	private static final Class[] modules=new Class[]{ComparisonModule.class};
	public ModuleControl createControl(){return new ScrollPane(new ComparisonPanel());}
	public Class[] getModules(){return modules;}
	public ControlPosition getPosition(){return ControlPosition.CENTER;}
}