package abchr.gui.modulecontrols;

import abchr.ProjectModule;
import abchr.TimeLineModule;
import abchr.SavedRangesModule;
import abchr.audio.PlaybackThread;
import guiutils.PlaybackRangeSelectBar;
import guiutils.RangeSelectBarPanel;

import javax.swing.*;
import java.awt.*;

public class TimeLinePanel extends JPanel implements ModuleControl {
	private RangeSelectBarPanel panel=new RangeSelectBarPanel();

	public TimeLinePanel(TimeLineModule module) {
		super(new BorderLayout());
		this.add(panel,BorderLayout.CENTER);
		this.setModule(module);
	}

	public TimeLinePanel(){this(null);}

	public void setModule(ProjectModule module) {
		panel.setEnabled(module!=null);
		if(module==null){return;}
		PlaybackRangeSelectBar rangeBar=panel.getRangeBar();
		if(module instanceof TimeLineModule) {
			TimeLineModule timeLineModule=(TimeLineModule)module;
			BoundedRangeModel model=timeLineModule.getRangeModel();
			rangeBar.setModel(model);
			PlaybackThread.getInstance().setRangeModel(model);
			rangeBar.setPosMarker(PlaybackThread.getInstance().getPosMarker());
		} else if(module instanceof SavedRangesModule) {
			rangeBar.setSavedRanges(((SavedRangesModule)module).getSavedRanges());
		}
	}
}
