package guiutils;

import jlfgr.GraphicsRepository;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public abstract class AbstractBrowseButton extends JButton implements ActionListener {
	protected JFileChooser fileChooser;
	protected final Component parent;
	protected boolean multiple;

	public AbstractBrowseButton(Component parent,JFileChooser fileChooser,boolean multiple) {
		this(null,parent,fileChooser,multiple);
		this.setMargin(new Insets(2,2,2,2));
		this.setIconTextGap(0);
	}

	public AbstractBrowseButton(String text,Component parent,JFileChooser fileChooser,boolean multiple) {
		super(text,GraphicsRepository.getToolbarIcon("general/Open16.gif"));
		this.fileChooser=fileChooser;
		this.parent=parent;
		this.multiple=multiple;
		this.addActionListener(this);
	}

	protected abstract void addFiles(File[] files);

	public void actionPerformed(ActionEvent e) {
		fileChooser.setMultiSelectionEnabled(multiple);
		if(fileChooser.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION) {
			if(multiple) {
				File[] files=fileChooser.getSelectedFiles();
				addFiles(files);
			} else {
				addFiles(new File[]{fileChooser.getSelectedFile()});
			}
		}
	}
}