package guiutils;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public class FileList extends JPanel {
	private DefaultListModel listModel=new DefaultListModel();
	private JList list=new JList(listModel);

	public FileList(JFileChooser fileChooser) {
		super(new BorderLayout());
		this.add(new JScrollPane(list),BorderLayout.CENTER);
		JPanel bottomPanel=new JPanel(new LineLayout(LineLayout.RIGHT_ALIGN,true));
		ListBrowseButton addButton=new ListBrowseButton("Add files",this,fileChooser,listModel,true);
		bottomPanel.add(addButton);
		JButton clearButton=new JButton("Remove All");
		clearButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){listModel.clear();}
		});
		bottomPanel.add(clearButton);
		this.add(bottomPanel,BorderLayout.SOUTH);
	}

	public ListModel getListModel() {
		return listModel;
	}

	public File[] getFiles() {
		File[] result=new File[listModel.size()];
		listModel.copyInto(result);
		return result;
	}

	public void clear(){listModel.clear();}
}
