package guiutils;

import abchr.TimeToString;

import javax.swing.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.*;
import java.awt.geom.Rectangle2D;

public class PlaybackRangeSelectBar extends RangeSelectBar {
	private PositionMarker posMarker=null;
	private ChangeListener posMarkerListener=new ChangeListener() {
		public void stateChanged(ChangeEvent e){repaint();}
	};

	public PlaybackRangeSelectBar(BoundedRangeModel model){super(model);}
	public PlaybackRangeSelectBar(int start,int end){super(start,end);}

	public PlaybackRangeSelectBar(int start,int end,PositionMarker posMarker) {
		this(start,end);
		setPosMarker(posMarker);
	}

	public PositionMarker getPosMarker(){return posMarker;}

	public void setPosMarker(PositionMarker posMarker) {
		if(this.posMarker!=null){this.posMarker.removeListener(posMarkerListener);}
		this.posMarker=posMarker;
		posMarker.addListener(posMarkerListener);
	}

	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		if(posMarker==null || !isEnabled()){return;}
		if(posMarker.getPosition()!=-1) {
			g.setColor(Color.RED);
			int x=rangeToDisplay(posMarker.getPosition());
			g.drawLine(x,0,x,this.getHeight());
		}
		int position=posMarker.getPosition()!=-1?posMarker.getPosition():getModel().getValue();
		String posString=TimeToString.durationToString(position);
		g.setColor(Color.BLACK);
		Rectangle2D stringBounds=g.getFontMetrics().getStringBounds(posString,g);
		g.drawString(posString,(int)(getWidth()-stringBounds.getWidth())/2,getHeight()/2+4);
	}
}
