package guiutils;

import abchr.TimeToString;

import javax.swing.*;
import java.awt.*;

public class RangeSelectBarPanel extends JPanel implements RangeSelectBarListener {
	private final PlaybackRangeSelectBar rangeBar;
	private final JTextField startField=new JTextField(4);
	private final JTextField endField=new JTextField(4);

	public RangeSelectBarPanel() {
		super(new BorderLayout(5,5));
		this.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		rangeBar=new PlaybackRangeSelectBar(20,100);
		rangeBar.addListener(this);
		startField.setEditable(false);
		startField.setHorizontalAlignment(JTextField.RIGHT);
		endField.setEditable(false);
		endField.setHorizontalAlignment(JTextField.RIGHT);
		this.add(startField,BorderLayout.WEST);
		this.add(rangeBar,BorderLayout.CENTER);
		this.add(endField,BorderLayout.EAST);
		this.add(new JLabel("Playback Range Selection",JLabel.CENTER),BorderLayout.SOUTH);
		this.setToolTipText("Click and Drag to select, double-click to select all; Alt+[number] to save range, Ctrl+[number] to restore range");
	}

	public PlaybackRangeSelectBar getRangeBar(){return rangeBar;}

	public void setEnabled(boolean b) {
		super.setEnabled(b);
		rangeBar.setEnabled(b);
		if(!b){startField.setText("");endField.setText("");}
	}

	public void selectionChanged(RangeSelectBar source,int selectionStart,int selectionEnd) {
		startField.setText(TimeToString.durationToString(selectionStart));
		endField.setText(TimeToString.durationToString(selectionEnd));
	}
}