package guiutils;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.util.List;
import java.util.ArrayList;
import java.io.Serializable;
import java.io.IOException;

public class SavedRangesModel implements Serializable {
	private Range[] ranges=new Range[10];

	public void set(int index,Range range){ranges[index]=range;notifyListeners();}
	public Range get(int index){return ranges[index];}

	private transient List listeners=new ArrayList(2);

	public void addListener(ChangeListener listener){listeners.add(listener);}
	public void removeListener(ChangeListener listener){listeners.remove(listener);}

	private void notifyListeners() {
		for(int i=0;i<listeners.size();i++){((ChangeListener)listeners.get(i)).stateChanged(new ChangeEvent(this));}
	}

	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		listeners=new ArrayList(2);
	}
}